# Before `make install' is performed this script should be runnable
# with `make test'. After `make install' it should work as `perl
# URLInputSource.t'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..2\n"; }
END {print "not ok 1\n" unless $loaded;}
use Carp;
use XML::Xerces;
use Cwd;

use lib 't';
use TestUtils qw(result);

# turn off annoying warnings
$SIG{__WARN__} = 'IGNORE';

$loaded = 1;
my $i = 1;
result(1,$i), $i++;

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):


#
# This test monitors a heinous setErrorHandler() bug, in which
#   no internal reference to the perl handler object was maintained
#   and so when it went out of scope it was destroyed, and caused
#   core dumps
#

my $file = '.domparsetest';
open(OUT,">$file")
  or die "Couldn't open $file for writing\n";

print OUT <<'EOT';
use Carp;
use XML::Xerces;
use Cwd;

use lib 't';
use TestUtils qw($DOM);

# turn off annoying warnings
$SIG{__WARN__} = 'IGNORE';

{
  my $ERROR_HANDLER = XML::Xerces::perlErrorHandler->new();
  $ERROR_HANDLER->setFatalErrorFunction(sub {exit(0);});
  $DOM->setErrorHandler($ERROR_HANDLER);
}
# a bogus URL to cause a fatal error
my $URL = "file://../foo";
$DOM->parse(XML::Xerces::URLInputSource->new(XML::Xerces::XMLURL->new($URL)));
EOT

# if we get an exit value of zero we succeeded
system("perl $file");
result(! $?, $i), $i++;

END {unlink $file;}
